
#include "CApp.h"

void CApp::OnEvent(SDL_Event* Event) {
	SDL_Keycode kcode;
	switch (Event->type) {
		case SDL_QUIT:
			Running = false;
			break;
		case SDL_KEYDOWN:
			kcode = Event->key.keysym.sym;

			switch (kcode) {
				case SDLK_KP_9:
					view->beginMovementKey(9);
					break;
				case SDLK_KP_7:
					view->beginMovementKey(7);
					break;
				case SDLK_KP_1:
					view->beginMovementKey(1);
					break;
				case SDLK_KP_3:
					view->beginMovementKey(3);
					break;
				case SDLK_KP_8:
					view->beginMovementKey(8);
					break;
				case SDLK_KP_2:
					view->beginMovementKey(2);
					break;
				case SDLK_KP_4:
					view->beginMovementKey(4);
					break;
				case SDLK_KP_6:
					view->beginMovementKey(6);
					break;

				case SDLK_KP_5:
					view->toggleCursorCamera();
					break;
				case SDLK_TAB:
					view->cycleSelectedObject();
					break;

				case SDLK_KP_PLUS:
					view->zoomIn();
					break;
				case SDLK_KP_MINUS:
					view->zoomOut();
					break;

				case SDLK_m:
					view->activateMapDisplay();
					break;
				case SDLK_p:
					view->mapPopulateStep();
					break;

				case SDLK_PAGEDOWN:
					view->increaseBaseRadius();
					break;
				case SDLK_PAGEUP:
					view->decreaseBaseRadius();
					break;
			};

			break;


		case SDL_KEYUP:

			kcode = Event->key.keysym.sym;

			switch(kcode) {
				case SDLK_KP_9:
					view->stopMovementKey(9);
					break;
				case SDLK_KP_7:
					view->stopMovementKey(7);
					break;
				case SDLK_KP_1:
					view->stopMovementKey(1);
					break;
				case SDLK_KP_3:
					view->stopMovementKey(3);
					break;
				case SDLK_KP_8:
					view->stopMovementKey(8);
					break;
				case SDLK_KP_2:
					view->stopMovementKey(2);
					break;
				case SDLK_KP_4:
					view->stopMovementKey(4);
					break;
				case SDLK_KP_6:
					view->stopMovementKey(6);
					break;
			}
	};
}

void CApp::OnExit() {
	Running = false;
}

