#ifndef __REALMCHARACTEROBJECTPOSITIONER_H
	#define __REALMCHARACTEROBJECTPOSITIONER_H

#include "RealmObjectPositioner.h"
#include "SceneMoveAnimator.h"
#include "RealmCharacterGroupPositioner.h"

class RealmSceneView;

class RealmCharacterObjectPositioner : public RealmObjectPositioner {
private:
	RealmCharacterGroupPositioner* GroupPositioner;

	// animator positions are to be calculated relative to the owning CharacterGroup's positioner
	SceneMoveAnimator SceneAnimator, ZoneAnimator, RegionAnimator;

	// character screen location source/target points during animation (relative to group location)
	XYLocation SourceOffsetLocation, TargetOffsetLocation;

public:
	RealmCharacterObjectPositioner(RealmCharacterGroupPositioner* group_positioner,
									RealmSceneView* scene_view, HexSpiralCoordinate start_scene_coordinate,
									RealmSceneView* zone_view, HexSpiralCoordinate start_zone_coordinate,
									RealmSceneView* region_view, HexSpiralCoordinate start_region_coordinate
									);

	virtual ~RealmCharacterObjectPositioner() {}

	void startTransition(ZoomState new_mode);

	void update();

	double getScaleFactor(); // derive from current zoom / view level
	XYLocation getScreenLocation();
};


#endif // __REALMCHARACTEROBJECTPOSITIONER_H
