#include "RealmNumberGenerator.h"


unsigned long RealmNumberGenerator::getNextSeed() {

	unsigned long m = 2147483648;
	unsigned long a = 1103515245;
	unsigned long c = 12345;

	return LastSeed = ( (LastSeed * a) + c ) % m;
}

unsigned long RealmNumberGenerator::getNextNumber(int pvcount) {
	return getNextSeed() % pvcount ;
}

/*
void RealmNumberGenerator::generateChildSeeds(int seedcount)
{
	ChildSeeds = new int[seedcount];
	ChildSeedCount = seedcount;

	for (int i = 0; i < seedcount; i++) {
		ChildSeeds[i] = getNextSeed();
	}
}
*/

int RealmNumberGenerator::calculateVarianceValue(int variance_level, int inputvalues[], int inputcount) {
	// method: take the average of all the input values
	// then add (or subtract) a deterministic random number up to the variance limit
	int totalval = 0;

	for (int i = 0; i < inputcount; i++) {
		totalval += inputvalues[i];
	}
	int avgval = totalval / inputcount;

	return avgval - (variance_level / 2) + getNextNumber(variance_level);
}

int RealmNumberGenerator::calculateWeightedVarianceValue(int variance_level, int inputvalues[], int weights[], int inputcount)
{
	int totalval = 0;
	int avgcount = 0;
	for (int i = 0; i < inputcount; i++) {
		totalval += inputvalues[i] * weights[i];
		avgcount += weights[i];
	}
	int avgval = totalval / avgcount;

	return avgval - (variance_level / 2) + getNextNumber(variance_level);
}
