#ifndef __REALMOBJECT_H
	#define __REALMOBJECT_H

#include <SDL2/SDL.h>
#include "XYLocation.h"
#include "HexSpiralCoordinate.h"

class RealmObjectType;
class RealmSceneView;
class SceneMoveAnimator;
class RealmObjectPositioner;

class RealmObject {
	protected:
		RealmObjectType *object_type;
		int width, height;
		RealmObjectPositioner* positioner;

	public:
		void init(RealmObjectType* otype, int w, int h);

		void setObjectPositioner(RealmObjectPositioner* op) { positioner = op; }
		RealmObjectPositioner* getObjectPositioner() { return positioner; }

		void draw(SDL_Renderer* renderer);
};

#endif // __REALMOBJECT_H
