#ifndef __REALMSCENEBACKGROUND_H
	#define __REALMSCENEBACKGROUND_H

#include "XYLocation.h"

class RealmSceneView;
class RealmSceneElevationMap;
class HexGridDisplay;
class RealmColorMap;
class SDL_Renderer;
class SDL_Texture;

class RealmSceneBackground {
public:
	RealmSceneBackground(long int spiral_index, RealmSceneElevationMap* emap, int gridsize, bool inverted);
	~RealmSceneBackground();

	bool needsUpdate();

	void update(RealmSceneView* scene_view);
	void drawToTexture(SDL_Renderer* renderer, SDL_Texture* texture, bool force_update);

	void setSize(int hex_radius);

private:

	int Width;
	int Height;
	bool Inverted;

	int GridSize;

	int HexRadius;

	XYLocation ScreenLocation;

	XYLocation getCenterCoordinate();

	RealmSceneElevationMap* Map;
	HexGridDisplay* HexGrid;
	XYLocation MapCoord;
	RealmColorMap* ColorMap;
};

#endif // __REALMSCENEBACKGROUND_H
