#include "RealmWorldObject.h"
#include "RealmSceneView.h"
#include "RealmView.h"

void RealmWorldObject::init(RealmObjectType* otype, int w, int h, XYLocation olocation ) {
	RealmObject::init(otype, w, h);

	RealmWorldLocation = olocation;
}

bool RealmWorldObject::operator < (const RealmWorldObject& o) const {
	return
		(RealmWorldLocation.y < o.getRealmWorldLocation().y ) ||
		( (RealmWorldLocation.y == o.getRealmWorldLocation().y) &&
		RealmWorldLocation.x < o.getRealmWorldLocation().x );
}

XYLocation RealmWorldObject::getScreenLocation() {
	XYLocation view_offset_location;
	int zoomlevel = realm_scene_view->getBaseLevel();
	view_offset_location.setx(
		(RealmWorldLocation.x -
		realm_scene_view->getMasterView()->getCurrentLocation().getRealmWorldCoordinate(zoomlevel+1).x)
		/
		realm_scene_view->getMasterView()->getCurrentLocation().getXScaleFactor(zoomlevel)
	);
	view_offset_location.sety(
		(RealmWorldLocation.y -
		realm_scene_view->getMasterView()->getCurrentLocation().getRealmWorldCoordinate(zoomlevel+1).y)
		/
		realm_scene_view->getMasterView()->getCurrentLocation().getYScaleFactor(zoomlevel)
	);

	return realm_scene_view->getScreenLocation(view_offset_location);
}

